#!/usr/bin/env python
#
# Copyright (C) 2006 Tejas Dinkar <tejasdinkar AT gmail DOT com>
#
# This program is part of system-config-control
#
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; version 2 of the License.
#


class Application:
    '''This Defines an Application. It stores the Command Name and the package name mostly'''
    def __init__(self, command, package = False):
        '''This will Accept the Name and the Package and Store it
	If no Package name Specified, it assumes it is the same'''
        self.command = command
        if package:
	    self.package = package
	else:
	    self.package = command
	
    def package_exists(self):
	'''Checks if the Program Exists'''
	import rpm
        TransactionSet = rpm.ts()
        installed = TransactionSet.dbMatch("name",self.package)
        for i in installed:
                return True
        return False


######################################
# Below this starts the naming of all the apps
# It must be of the following form
# widget_name = Application(command = , package = )
######################################

def _fedora_core_5():
	app_kickstart = Application(command = 'system-config-kickstart')
	app_pirut = Application(command = 'pirut')
	
	app_display = Application(command = 'system-config-display')
	app_soundcard = Application(command = 'system-config-soundcard')
	app_hwbrowser = Application(command = 'hwbrowser')
	app_mouse = Application(command = 'system-config-mouse')
	app_printer = Application(command = 'system-config-printer')
	app_keyboard = Application(command = 'system-config-keyboard')
	
	app_boot = Application(command = 'system-config-boot')
	app_date = Application(command = 'system-config-date')
	app_language = Application(command = 'system-config-language')
	app_lvm = Application(command = 'system-config-lvm')
	
	app_net_config = Application(command = 'system-config-network')
	app_net_wizard = Application(command = 'internet-druid', 
					package = 'system-config-network')
	app_netboot = Application(command = 'system-config-netboot')
	app_net_control = Application(command = 'system-config-network')
	
	app_bind = Application(command = 'system-config-bind')
	app_nfs = Application(command = 'system-config-nfs')
	app_services = Application(command = 'system-config-services')
	app_httpd = Application(command = 'system-config-httpd')
	app_samba = Application(command = 'system-config-samba')
	app_authentication = Application(command = 'system-config-authentication', 
						package = "authconfig-gtk")
	
	app_users = Application(command = 'system-config-users')
	app_rootpassword = Application(command = 'system-config-rootpassword')
	app_securitylevel = Application(command = 'system-config-securitylevel')
	app_userinfo = Application(command = 'userinfo', package = 'usermode-gtk')
	
	app_switchdesk = Application(command = 'switchdesk', package = "switchdesk-gui")
	app_sys_log = Application(command = 'system-logviewer')
	
	return locals()


#############################################
# Functions to Check for Distros

def _is_fedora_core_5():
	'''I don't know how to figure out if we are Fedora or Not.
	Upto the RHEL guys to do this part'''
	return True

def _is_RHEL():
	return False


##############################################
### void main() <--- Note, this is run even if imported

if _is_fedora_core_5():
	applications = _fedora_core_5()
